;
;Phoenix RAM test program (default bank)
;
;to be burned on a EPROM and set to first ROM location on a Phoenix board
;
;USE AT YOUR OWN RISK !!!!
;
; set "load me at" / "laden bei"
; on top of assembly editor 
; to 0000 !!

;.org 0000h

; definitions
rambase1:  equ  04000h
ramsize1:  equ  1024
rambase2:  equ  04800h
ramsize2:  equ  1024

; reset vector
jmp start              ;jump to code skipping data

;code starts here
start:	mvi  b, 0ffh
	lxi  h, rambase1
	lxi  d, ramsize1
loop1:	mvi  a, 055h
	mov  m, a
	cmp  m
	jnz  stop
	xra  b
	mov  m, a
	cmp  m
	jnz  stop

	inx  h
	dcx  d
	mov  a, d
	ora  e
	jnz  loop1

	lxi  h, rambase2
	lxi  d, ramsize2
loop2:	mvi  a, 055h
	mov  m, a
	cmp  m
	jnz  stop
	xra  b
	mov  m, a
	cmp  m
	jnz  stop

	inx  h
	dcx  d
	mov  a, d
	ora  e
	jnz  loop2

rerun:	jmp  start

stop:	hlt  ;halt execution

start2:	lxi  h, 05000h
	mvi  a, 01h
	mov  m, a
	jmp start

;data starts here
